defmodule AoC do

  def reduce(number) do
    case reduce_step(number) do
      {_op, number} ->
        # try to reduce again
        reduce(number)
      number ->
        # we are done!
        number
    end
  end

  def reduce_step(number) do
    number
    |> explode()
    |> split()
  end

  defp explode(number) do
    case do_explode(number, 0) do
      :todo -> number
      {_, new_number} -> {:boom, new_number}
    end
  end

  defp do_explode([[ll, lr], r], 3) do
    {{:push_l, ll}, [0, ex_add({:l, lr}, r)]}
  end
  defp do_explode([l, [rl, rr]], 3) do
    {{:push_r, rr}, [ex_add({:r, rl}, l), 0]}
  end
  defp do_explode(_, 3), do: :todo

  defp do_explode([l, r], level) do
    case do_explode(l, level+1) do
      {{:push_l, x}, n} -> {{:push_l, x}, [n, r]}
      {{:push_r, x}, n} -> {:done, [n, ex_add({:l, x}, r)]}
      {:done, n} -> {:done, [n,r]}
      :todo ->
        case do_explode(r, level+1) do
          {{:push_l, x}, n} -> {:done, [ex_add({:r, x}, l), n]}
          {{:push_r, x}, n} -> {{:push_r, x}, [l, n]}
          {:done, n} -> {:done, [l,n]}
          :todo -> :todo
        end
    end
  end
  defp do_explode(_, _), do: :todo

  defp ex_add({:l, x}, [l,r]), do: [ex_add({:l, x}, l), r]
  defp ex_add({:r, x}, [l,r]), do: [l, ex_add({:r, x}, r)]
  defp ex_add({_, x}, n), do: n + x

  defp split({op, number}),
    # already exploded this round
    # => skipping
    do: {op, number}

  defp split([l,r]) do
    case split(l) do
      {:snip, n} -> {:snip, [n,r]}
      _ ->
        case split(r) do
          {:snip, n} -> {:snip, [l,n]}
          _ -> [l,r]
        end
    end
  end
  defp split(n) when n > 9, do: {:snip, [floor(n/2), ceil(n/2)]}
  defp split(n), do: n

  def add(l, r), do: reduce([l, r])

  def magnitude([l,r]), do: 3*magnitude(l) + 2*magnitude(r)
  def magnitude(n), do: n

  def max_magnitude(numbers) do
    numbers
    |> Enum.flat_map(fn l ->
      Enum.map(numbers, fn r ->
        l |> add(r) |> magnitude()
      end)
    end)
    |> Enum.max()
  end

end

ExUnit.start()

defmodule AoCTest do
  use ExUnit.Case

  describe "reduce" do
    test "noop 1" do
      number = [1,2]
      assert AoC.reduce(number) == number
    end
    test "noop 2" do
      number = [[[[1,3],[5,3]],[[1,3],[8,7]]],[[[4,9],[6,9]],[[8,2],[7,3]]]]
      assert AoC.reduce(number) == number
    end
  end

  describe "reduce_step" do
    test "explode left border" do
      number_1 = [[[[[9,8],1],2],3],4]
      number_2 = [[[[0,9],2],3],4]
      assert AoC.reduce_step(number_1) == {:boom, number_2}
    end
    test "explode right border" do
      number_1 = [7,[6,[5,[4,[3,2]]]]]
      number_2 = [7,[6,[5,[7,0]]]]
      assert AoC.reduce_step(number_1) == {:boom, number_2}
    end
    test "explode 1" do
      number_1 = [[6,[5,[4,[3,2]]]],1]
      number_2 = [[6,[5,[7,0]]],3]
      assert AoC.reduce_step(number_1) == {:boom, number_2}
    end
    test "explode 2" do
      number_1 = [[3,[2,[1,[7,3]]]],[6,[5,[4,[3,2]]]]]
      number_2 = [[3,[2,[8,0]]],[9,[5,[4,[3,2]]]]]
      assert AoC.reduce_step(number_1) == {:boom, number_2}
    end
    test "explode 3" do
      number_1 = [[3,[2,[8,0]]],[9,[5,[4,[3,2]]]]]
      number_2 = [[3,[2,[8,0]]],[9,[5,[7,0]]]]
      assert AoC.reduce_step(number_1) == {:boom, number_2}
    end

    test "explode sum" do
      number_1 = [[[[[1,1],[2,2]],[3,3]],[4,4]],[5,5]]
      number_2 = [[[[0,[3,2]],[3,3]],[4,4]],[5,5]]
      assert AoC.reduce_step(number_1) == {:boom, number_2}
    end

    test "full reduction (explode + split)" do
      number_1 = [[[[[4,3],4],4],[7,[[8,4],9]]],[1,1]]
      number_2 = [[[[0,7],4],[7,[[8,4],9]]],[1,1]]
      number_3 = [[[[0,7],4],[15,[0,13]]],[1,1]]
      number_4 = [[[[0,7],4],[[7,8],[0,13]]],[1,1]]
      number_5 = [[[[0,7],4],[[7,8],[0,[6,7]]]],[1,1]]
      number_6 = [[[[0,7],4],[[7,8],[6,0]]],[8,1]]
      assert AoC.reduce_step(number_1) == {:boom, number_2}
      assert AoC.reduce_step(number_2) == {:boom, number_3}
      assert AoC.reduce_step(number_3) == {:snip, number_4}
      assert AoC.reduce_step(number_4) == {:snip, number_5}
      assert AoC.reduce_step(number_5) == {:boom, number_6}
    end
  end

  test "add list 1,1 + 2,2" do
    n_1 = [1,1]
    n_2 = [2,2]
    sum = [[1,1],[2,2]]
    assert AoC.add(n_1, n_2) == sum
  end

  test "add list 1,1 + 2,2 + 3,3 + 4,4" do
    sum = [1,1]
    |> AoC.add([2,2])
    |> AoC.add([3,3])
    |> AoC.add([4,4])
    assert sum == [[[[1,1],[2,2]],[3,3]],[4,4]]
  end

  test "add list 1,1 + 2,2 + 3,3 + 4,4 + 5,5" do
    sum = [1,1]
    |> AoC.add([2,2])
    |> AoC.add([3,3])
    |> AoC.add([4,4])
    |> AoC.add([5,5])
    assert sum == [[[[3,0],[5,3]],[4,4]],[5,5]]
  end

  test "add 2" do
    n_1 = [[[0,[4,5]],[0,0]],[[[4,5],[2,6]],[9,5]]]
    n_2 = [7,[[[3,7],[4,3]],[[6,3],[8,8]]]]
    sum = [[[[4,0],[5,4]],[[7,7],[6,0]]],[[8,[7,7]],[[7,9],[5,0]]]]
    assert AoC.add(n_1, n_2) == sum
  end

  test "magnitude" do
    assert AoC.magnitude([[1,2],[[3,4],5]]) == 143
    assert AoC.magnitude([[[[0,7],4],[[7,8],[6,0]]],[8,1]]) == 1384
    assert AoC.magnitude([[[[1,1],[2,2]],[3,3]],[4,4]]) == 445
    assert AoC.magnitude([[[[3,0],[5,3]],[4,4]],[5,5]]) == 791
    assert AoC.magnitude([[[[5,0],[7,4]],[5,5]],[6,6]]) == 1137
  end

  test "part 1 - example" do
    data = [
      [[[0,[5,8]],[[1,7],[9,6]]],[[4,[1,2]],[[1,4],2]]],
      [[[5,[2,8]],4],[5,[[9,9],0]]],
      [6,[[[6,2],[5,6]],[[7,6],[4,7]]]],
      [[[6,[0,7]],[0,9]],[4,[9,[9,0]]]],
      [[[7,[6,4]],[3,[1,3]]],[[[5,5],1],9]],
      [[6,[[7,3],[3,2]]],[[[3,8],[5,7]],4]],
      [[[[5,4],[7,7]],8],[[8,3],8]],
      [[9,3],[[9,9],[6,[4,9]]]],
      [[2,[[7,7],7]],[[5,8],[[9,3],[0,2]]]],
      [[[[5,2],5],[8,[3,7]]],[[5,[7,5]],[4,4]]],
    ]

    mag = data
    |> Enum.reduce(fn number, acc -> AoC.add(acc, number) end)
    |> AoC.magnitude()

    assert mag == 4140
  end

  test "part 1 - real" do
    data = [
      [5,[5,0]],
      [[[[8,4],3],[6,7]],[[[7,4],2],[[5,7],[1,5]]]],
      [[[[7,6],[4,6]],1],[[5,7],[0,[2,1]]]],
      [[[[5,8],[3,5]],[9,0]],[[[4,0],[4,1]],[[9,3],1]]],
      [7,[[[6,4],[2,7]],[[8,8],5]]],
      [[9,6],[1,[[4,5],3]]],
      [[[7,1],[2,4]],[[[6,2],[1,6]],[8,8]]],
      [[[[1,9],[1,1]],[2,9]],5],
      [7,[[[0,0],8],[[5,2],[7,6]]]],
      [[[8,[8,7]],6],[7,[6,2]]],
      [[3,[1,3]],[9,[[0,9],0]]],
      [[4,[9,[0,3]]],[[9,[4,6]],4]],
      [[[6,[5,9]],1],[[0,[0,4]],[[1,2],7]]],
      [[[8,[1,2]],0],6],
      [[[[1,2],2],[[8,9],9]],[[4,6],[[7,9],[0,0]]]],
      [[[[1,3],[0,3]],[2,[8,6]]],[[3,[5,3]],6]],
      [[7,7],[[[1,1],[5,6]],[[2,8],[8,7]]]],
      [8,[6,[9,[2,1]]]],
      [9,[2,[9,9]]],
      [[6,[[5,0],9]],[7,[[1,9],3]]],
      [[4,[8,[7,8]]],[[4,[4,0]],[[9,8],3]]],
      [5,[[2,3],[7,4]]],
      [[[[3,9],1],[8,4]],[[7,5],[[1,4],[6,4]]]],
      [[5,[7,0]],[5,8]],
      [[[[8,5],[8,7]],0],[[7,4],6]],
      [[4,[4,[8,7]]],[9,[7,7]]],
      [[4,[[2,9],8]],[2,[1,6]]],
      [[[6,[5,5]],[3,9]],[2,[[6,3],[2,5]]]],
      [[2,[7,2]],[[[9,3],6],[8,4]]],
      [[[[0,2],[7,1]],[[6,4],5]],[[5,[5,2]],[[0,4],[5,9]]]],
      [[[6,3],[[3,0],9]],[[[2,7],[1,1]],[[4,5],[0,1]]]],
      [[[4,[9,4]],[[7,3],[6,4]]],5],
      [[4,[9,8]],9],
      [7,[[[1,1],3],[[0,2],9]]],
      [[[[7,1],6],[[0,4],[5,9]]],[3,[[0,2],[1,9]]]],
      [[[0,6],[1,[4,2]]],[9,7]],
      [[[8,[9,7]],0],[[[3,4],1],8]],
      [[[7,0],[0,4]],[[2,1],[[6,7],8]]],
      [[2,7],[[6,9],[[0,1],[7,3]]]],
      [[[[0,0],[3,2]],4],[[6,2],1]],
      [[[[4,6],2],[[5,3],1]],1],
      [[[2,[3,5]],[5,[4,5]]],[[[2,9],0],[1,2]]],
      [[[3,8],[7,[4,5]]],4],
      [[[9,[5,2]],[[3,8],9]],[[6,6],8]],
      [[[[9,1],[6,7]],[[0,5],1]],[[7,[3,0]],0]],
      [4,[[[6,8],2],[[3,5],5]]],
      [[[[1,0],7],[7,[1,2]]],[[6,8],[[4,2],[3,3]]]],
      [[5,[7,[2,5]]],2],
      [[[[6,9],0],[[7,2],[3,3]]],[3,[[4,9],3]]],
      [[4,[0,8]],[6,2]],
      [[6,[5,6]],[[[4,1],7],5]],
      [[6,[2,[1,5]]],[[[0,5],0],[7,[1,2]]]],
      [[[[9,7],9],[4,2]],[6,[[8,6],[6,0]]]],
      [3,[[2,[7,2]],[1,9]]],
      [[6,9],[[3,0],7]],
      [[[[5,2],[8,8]],[[8,1],6]],[[[9,0],2],[4,5]]],
      [[[7,0],[[6,8],[9,1]]],[1,[1,[6,0]]]],
      [[[2,[8,2]],[[1,4],[7,8]]],8],
      [[[[7,8],7],7],[[[6,4],0],[8,3]]],
      [[6,2],[8,8]],
      [[[8,[2,0]],7],[7,[[4,3],[9,8]]]],
      [[[[8,5],[2,5]],4],[[[9,2],[5,1]],[[0,5],[0,6]]]],
      [[[0,[9,9]],4],[[[3,8],6],[3,[6,7]]]],
      [[[7,4],[8,7]],[[[1,1],4],[[3,6],[1,2]]]],
      [[[[0,3],[8,6]],[8,3]],[4,[1,[4,7]]]],
      [[[8,2],[6,[2,1]]],[[1,[8,4]],[3,[3,2]]]],
      [[[[7,4],2],[2,[7,9]]],[[[7,9],6],[2,1]]],
      [[[5,[7,4]],[1,[6,2]]],[[1,[8,9]],[[2,8],5]]],
      [[5,4],[[[6,9],0],[[1,2],9]]],
      [0,[0,0]],
      [4,[[[2,3],9],[[0,5],[8,0]]]],
      [[[9,6],[3,0]],[9,[0,4]]],
      [[[5,[4,0]],8],[[3,[6,1]],[7,[5,7]]]],
      [[[[2,8],[0,1]],[9,[8,0]]],[[[2,8],[2,0]],1]],
      [[[[0,7],5],[[3,3],[0,3]]],[[8,[0,6]],[[4,3],2]]],
      [[[[5,0],[2,2]],2],[[7,[6,4]],[6,[6,4]]]],
      [[[[2,7],[0,0]],8],[[[3,0],2],[0,7]]],
      [[[5,[7,6]],[1,[6,8]]],[[5,[9,3]],[[8,1],4]]],
      [[[[1,1],[0,5]],[[7,6],5]],[[7,4],[4,[3,6]]]],
      [[[4,[1,6]],[4,0]],[[[8,9],[4,6]],[9,[4,9]]]],
      [[[[7,7],[8,5]],[4,[2,2]]],[0,[8,[0,4]]]],
      [[[2,1],9],[5,[[8,9],8]]],
      [[[0,7],[9,[0,9]]],[3,3]],
      [[8,7],[[8,7],2]],
      [1,[[9,7],9]],
      [[[[3,4],[7,3]],3],[[2,[8,2]],[[8,1],[6,3]]]],
      [[5,7],[0,[[3,4],[0,3]]]],
      [[[[3,3],2],[4,2]],[[7,[2,4]],[5,7]]],
      [[[[9,4],[9,5]],1],[[6,7],[6,6]]],
      [8,[3,5]],
      [[[3,0],8],[2,[3,7]]],
      [3,[[[7,0],5],[[2,2],[8,9]]]],
      [[9,[4,6]],[[[3,6],8],[5,0]]],
      [[[9,5],[[8,7],[0,0]]],[[8,[8,9]],[6,[8,1]]]],
      [[[4,5],[[1,7],[9,1]]],[[[5,7],[8,9]],[[4,8],5]]],
      [[[[0,7],8],[8,0]],[2,[[5,4],2]]],
      [[[8,4],6],[3,[[0,7],[8,0]]]],
      [[[[1,4],[3,7]],[[6,9],0]],[5,5]],
      [[3,[[6,1],[8,7]]],[[7,8],9]],
      [[[[8,5],[7,5]],[[1,0],[2,7]]],[1,[[2,3],[2,8]]]],
    ]

    mag = data
    |> Enum.reduce(fn number, acc -> AoC.add(acc, number) end)
    |> AoC.magnitude()

    assert mag == 4391
  end

  test "part 2 - example" do
    data = [
      [[[0,[5,8]],[[1,7],[9,6]]],[[4,[1,2]],[[1,4],2]]],
      [[[5,[2,8]],4],[5,[[9,9],0]]],
      [6,[[[6,2],[5,6]],[[7,6],[4,7]]]],
      [[[6,[0,7]],[0,9]],[4,[9,[9,0]]]],
      [[[7,[6,4]],[3,[1,3]]],[[[5,5],1],9]],
      [[6,[[7,3],[3,2]]],[[[3,8],[5,7]],4]],
      [[[[5,4],[7,7]],8],[[8,3],8]],
      [[9,3],[[9,9],[6,[4,9]]]],
      [[2,[[7,7],7]],[[5,8],[[9,3],[0,2]]]],
      [[[[5,2],5],[8,[3,7]]],[[5,[7,5]],[4,4]]],
    ]

    assert AoC.max_magnitude(data) == 3993
  end

    test "part 2 - real" do
    data = [
      [5,[5,0]],
      [[[[8,4],3],[6,7]],[[[7,4],2],[[5,7],[1,5]]]],
      [[[[7,6],[4,6]],1],[[5,7],[0,[2,1]]]],
      [[[[5,8],[3,5]],[9,0]],[[[4,0],[4,1]],[[9,3],1]]],
      [7,[[[6,4],[2,7]],[[8,8],5]]],
      [[9,6],[1,[[4,5],3]]],
      [[[7,1],[2,4]],[[[6,2],[1,6]],[8,8]]],
      [[[[1,9],[1,1]],[2,9]],5],
      [7,[[[0,0],8],[[5,2],[7,6]]]],
      [[[8,[8,7]],6],[7,[6,2]]],
      [[3,[1,3]],[9,[[0,9],0]]],
      [[4,[9,[0,3]]],[[9,[4,6]],4]],
      [[[6,[5,9]],1],[[0,[0,4]],[[1,2],7]]],
      [[[8,[1,2]],0],6],
      [[[[1,2],2],[[8,9],9]],[[4,6],[[7,9],[0,0]]]],
      [[[[1,3],[0,3]],[2,[8,6]]],[[3,[5,3]],6]],
      [[7,7],[[[1,1],[5,6]],[[2,8],[8,7]]]],
      [8,[6,[9,[2,1]]]],
      [9,[2,[9,9]]],
      [[6,[[5,0],9]],[7,[[1,9],3]]],
      [[4,[8,[7,8]]],[[4,[4,0]],[[9,8],3]]],
      [5,[[2,3],[7,4]]],
      [[[[3,9],1],[8,4]],[[7,5],[[1,4],[6,4]]]],
      [[5,[7,0]],[5,8]],
      [[[[8,5],[8,7]],0],[[7,4],6]],
      [[4,[4,[8,7]]],[9,[7,7]]],
      [[4,[[2,9],8]],[2,[1,6]]],
      [[[6,[5,5]],[3,9]],[2,[[6,3],[2,5]]]],
      [[2,[7,2]],[[[9,3],6],[8,4]]],
      [[[[0,2],[7,1]],[[6,4],5]],[[5,[5,2]],[[0,4],[5,9]]]],
      [[[6,3],[[3,0],9]],[[[2,7],[1,1]],[[4,5],[0,1]]]],
      [[[4,[9,4]],[[7,3],[6,4]]],5],
      [[4,[9,8]],9],
      [7,[[[1,1],3],[[0,2],9]]],
      [[[[7,1],6],[[0,4],[5,9]]],[3,[[0,2],[1,9]]]],
      [[[0,6],[1,[4,2]]],[9,7]],
      [[[8,[9,7]],0],[[[3,4],1],8]],
      [[[7,0],[0,4]],[[2,1],[[6,7],8]]],
      [[2,7],[[6,9],[[0,1],[7,3]]]],
      [[[[0,0],[3,2]],4],[[6,2],1]],
      [[[[4,6],2],[[5,3],1]],1],
      [[[2,[3,5]],[5,[4,5]]],[[[2,9],0],[1,2]]],
      [[[3,8],[7,[4,5]]],4],
      [[[9,[5,2]],[[3,8],9]],[[6,6],8]],
      [[[[9,1],[6,7]],[[0,5],1]],[[7,[3,0]],0]],
      [4,[[[6,8],2],[[3,5],5]]],
      [[[[1,0],7],[7,[1,2]]],[[6,8],[[4,2],[3,3]]]],
      [[5,[7,[2,5]]],2],
      [[[[6,9],0],[[7,2],[3,3]]],[3,[[4,9],3]]],
      [[4,[0,8]],[6,2]],
      [[6,[5,6]],[[[4,1],7],5]],
      [[6,[2,[1,5]]],[[[0,5],0],[7,[1,2]]]],
      [[[[9,7],9],[4,2]],[6,[[8,6],[6,0]]]],
      [3,[[2,[7,2]],[1,9]]],
      [[6,9],[[3,0],7]],
      [[[[5,2],[8,8]],[[8,1],6]],[[[9,0],2],[4,5]]],
      [[[7,0],[[6,8],[9,1]]],[1,[1,[6,0]]]],
      [[[2,[8,2]],[[1,4],[7,8]]],8],
      [[[[7,8],7],7],[[[6,4],0],[8,3]]],
      [[6,2],[8,8]],
      [[[8,[2,0]],7],[7,[[4,3],[9,8]]]],
      [[[[8,5],[2,5]],4],[[[9,2],[5,1]],[[0,5],[0,6]]]],
      [[[0,[9,9]],4],[[[3,8],6],[3,[6,7]]]],
      [[[7,4],[8,7]],[[[1,1],4],[[3,6],[1,2]]]],
      [[[[0,3],[8,6]],[8,3]],[4,[1,[4,7]]]],
      [[[8,2],[6,[2,1]]],[[1,[8,4]],[3,[3,2]]]],
      [[[[7,4],2],[2,[7,9]]],[[[7,9],6],[2,1]]],
      [[[5,[7,4]],[1,[6,2]]],[[1,[8,9]],[[2,8],5]]],
      [[5,4],[[[6,9],0],[[1,2],9]]],
      [0,[0,0]],
      [4,[[[2,3],9],[[0,5],[8,0]]]],
      [[[9,6],[3,0]],[9,[0,4]]],
      [[[5,[4,0]],8],[[3,[6,1]],[7,[5,7]]]],
      [[[[2,8],[0,1]],[9,[8,0]]],[[[2,8],[2,0]],1]],
      [[[[0,7],5],[[3,3],[0,3]]],[[8,[0,6]],[[4,3],2]]],
      [[[[5,0],[2,2]],2],[[7,[6,4]],[6,[6,4]]]],
      [[[[2,7],[0,0]],8],[[[3,0],2],[0,7]]],
      [[[5,[7,6]],[1,[6,8]]],[[5,[9,3]],[[8,1],4]]],
      [[[[1,1],[0,5]],[[7,6],5]],[[7,4],[4,[3,6]]]],
      [[[4,[1,6]],[4,0]],[[[8,9],[4,6]],[9,[4,9]]]],
      [[[[7,7],[8,5]],[4,[2,2]]],[0,[8,[0,4]]]],
      [[[2,1],9],[5,[[8,9],8]]],
      [[[0,7],[9,[0,9]]],[3,3]],
      [[8,7],[[8,7],2]],
      [1,[[9,7],9]],
      [[[[3,4],[7,3]],3],[[2,[8,2]],[[8,1],[6,3]]]],
      [[5,7],[0,[[3,4],[0,3]]]],
      [[[[3,3],2],[4,2]],[[7,[2,4]],[5,7]]],
      [[[[9,4],[9,5]],1],[[6,7],[6,6]]],
      [8,[3,5]],
      [[[3,0],8],[2,[3,7]]],
      [3,[[[7,0],5],[[2,2],[8,9]]]],
      [[9,[4,6]],[[[3,6],8],[5,0]]],
      [[[9,5],[[8,7],[0,0]]],[[8,[8,9]],[6,[8,1]]]],
      [[[4,5],[[1,7],[9,1]]],[[[5,7],[8,9]],[[4,8],5]]],
      [[[[0,7],8],[8,0]],[2,[[5,4],2]]],
      [[[8,4],6],[3,[[0,7],[8,0]]]],
      [[[[1,4],[3,7]],[[6,9],0]],[5,5]],
      [[3,[[6,1],[8,7]]],[[7,8],9]],
      [[[[8,5],[7,5]],[[1,0],[2,7]]],[1,[[2,3],[2,8]]]],
    ]

    assert AoC.max_magnitude(data) == 4626
  end
end
